/**
 * Present.java
 *
 * File generated from the XValidator4::Present uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

// End of user code
import java.util.ArrayList;
import java.util.Map;

import javax.persistence.CascadeType;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;
import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;
import net.ihe.gazelle.xvalidation.core.report.Notification;
import net.ihe.gazelle.xvalidation.core.xpath.XpathUtils;

import org.w3c.dom.Node;

/**
 * Description of the class Present.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "True", propOrder = { "xpath" })
@XmlRootElement(name = "True")
@Entity
@DiscriminatorValue("true")
public class True extends AbstractExpression implements java.io.Serializable {

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;

	@XmlElement(name = "XPath", required = true)
	@OneToOne(cascade = { CascadeType.ALL })
	@JoinColumn(name = "xpath_id")
	private Locator xpath;

	public True() {
		super();
		this.xpath = new Locator();
	}

	public True(True exp){
		super();
		this.xpath = new Locator(exp.getXpath());
	}
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * Return locator.
	 * 
	 * @return locator
	 */
	public Locator getXpath() {
		return xpath;
	}

	/**
	 * Set a value to attribute locator.
	 * 
	 * @param locator
	 *            .
	 */
	public void setXpath(Locator locator) {
		this.xpath = locator;
	}

	@Override
	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "True", this);
		}
		return xmlNodePresentation;
	}

	@Override
	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	@Override
	public Notification evaluate(Map<String, Node> documents, ValidatorConfiguration configuration, Level level) {

		boolean result;
		try {
			result = XpathUtils.getBooleanValue(documents.get(xpath.getAppliesOn()), xpath,
					configuration.getNamespaceContext());
		} catch (GazelleXValidationException e){
			return abort("Error evaluating XPath : " + e.getMessage(), xpath, "Error evaluating XPath " + xpath.toString() + " : " + e.getMessage());
		}

		Notification resultNotification;
		if (!result){
			resultNotification = newNotificationForLevel(level);
		} else {
			resultNotification = newNotificationForLevel(null);
		}
		resultNotification.setXpathReport(XpathUtils.getXPathReport(xpath, result));
		return resultNotification;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append('(');
		builder.append(this.xpath.toString());
		builder.append(") = true");
		return builder.toString();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = (prime * result) + ((xpath == null) ? 0 : xpath.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		True other = (True) obj;
		if (xpath == null) {
			if (other.xpath != null) {
				return false;
			}
		} else if (!xpath.equals(other.xpath)) {
			return false;
		}
		return true;
	}

	@Override
	public String getEditLink() {
		return "/xvalidation/expressions/true.xhtml";
	}

	@Override
	public void testCorrectness() throws AssertionFailedError {
		Assert.assertNotNull("[Expression #" + getFakeId() +"] XPath to execute is missing", xpath);
		Assert.assertTrue(xpath.isValued());
	}

	@Override
	public ArrayList<String> appliesTo() throws AssertionFailedError {
		ArrayList<String> keywords = new ArrayList<String>();
		testCorrectness();
		keywords.add(xpath.getAppliesOn());
		return keywords;
	}

	@Override
	public AbstractExpression createCopy() {
		return new True(this);
	}
}